﻿/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/
var depthStep;
var depth;
var step;
var numberOfLayers;
function auto(){
if(app.activeDocument.mode=="DocumentMode.BITMAP"){
    app.activeDocument.changeMode(ChangeMode.GRAYSCALE); 
    }
if(app.activeDocument.mode!="DocumentMode.RGB"){
    app.activeDocument.changeMode(ChangeMode.RGB); 
    }
app.activeDocument.duplicate('[3dLayers] ' + app.activeDocument.name);
var ad = app.activeDocument;
var layersArray = new Array
var depthLevel;
var placed = false;
var currentLayerName;
numberOfLayers = app.activeDocument.layers.length;
cTID = function(s) { return app.charIDToTypeID(s); };
sTID = function(s) { return app.stringIDToTypeID(s); };
Stdlib = function Stdlib() {};
Stdlib.getLayerDescriptor = function(layer) {
    var ref = new ActionReference();
    ref.putEnumerated(cTID("Lyr "), cTID("Ordn"), cTID("Trgt"));
    return executeActionGet(ref)
};
Stdlib.getLayerID = function(layer) {
  var d = Stdlib.getLayerDescriptor(layer);
  return d.getInteger(cTID('LyrI'));
};

try{
      activeDocument.backgroundLayer;
      hasBackgroundLayer = true;
   }catch(e){
      hasBackgroundLayer = false;
   }
if (hasBackgroundLayer){numberOfLayers=numberOfLayers-1};
if (numberOfLayers<3){alert("i need more layers")};
for (i=0; i<numberOfLayers; i++){
ad.activeLayer=ad.layers[i]
var layerId = Stdlib.getLayerID(ad.activeLayer);
layersArray[i]=layerId;
}
if (app.documents.length<1){alert("i need somthing to work on")}else{
var dw=ad.width;
step = dw/100
}
var depthLevel= 2
depthStep = ((depthLevel*2)/(numberOfLayers));
var loop=0;
while (loop <numberOfLayers){
    setActiveLayer(i);
    depth = Number(step*(depthLevel));
    currentLayerName = app.activeDocument.activeLayer.name
    stereo();
    depthLevel= (depthLevel-depthStep).toFixed(1);
    loop++
}
function setActiveLayer(i){
var nextId=layersArray[loop]
var idslct = charIDToTypeID( "slct" );
var desc18 = new ActionDescriptor();
var idnull = charIDToTypeID( "null" );
var ref11 = new ActionReference();
var idLyr = charIDToTypeID( "Lyr " );
ref11.putIdentifier( idLyr, nextId );
desc18.putReference( idnull, ref11 );
var idMkVs = charIDToTypeID( "MkVs" );
desc18.putBoolean( idMkVs, false );
executeAction( idslct, desc18, DialogModes.NO );
}
function stereo(){
getLayerIndex();
ad.activeLayer.duplicate();
ad.activeLayer.remove();
ad.activeLayer=ad.layers[currentLayer];
cyan();
ad.activeLayer.duplicate();
ad.activeLayer=ad.layers[currentLayer];
red();
var idslct = charIDToTypeID( "slct" );
var desc1115 = new ActionDescriptor();
var idnull = charIDToTypeID( "null" );
var ref670 = new ActionReference();
var idLyr = charIDToTypeID( "Lyr " );
ref670.putName( idLyr, currentLayerName+" Left" );
desc1115.putReference( idnull, ref670 );
var idselectionModifier = stringIDToTypeID( "selectionModifier" );
var idselectionModifierType = stringIDToTypeID( "selectionModifierType" );
var idaddToSelection = stringIDToTypeID( "addToSelection" );
desc1115.putEnumerated( idselectionModifier, idselectionModifierType, idaddToSelection );
var idMkVs = charIDToTypeID( "MkVs" );
desc1115.putBoolean( idMkVs, false );
executeAction( idslct, desc1115, DialogModes.NO );
var desc6 = new ActionDescriptor();
var ref6 = new ActionReference();
ref6.putClass( stringIDToTypeID('layerSection') );
desc6.putReference( charIDToTypeID('null'), ref6 );
var ref7 = new ActionReference();
ref7.putEnumerated( charIDToTypeID('Lyr '), charIDToTypeID('Ordn'), charIDToTypeID('Trgt') );
desc6.putReference( charIDToTypeID('From'), ref7 );
executeAction( charIDToTypeID('Mk  '), desc6, DialogModes.NO );
for (i=0; i<app.activeDocument.layers.length; i++) {
var layerName = app.activeDocument.layers[i].name;
if (layerName.charAt(0)=="+"||layerName.charAt(0)=="-"){
var otherDepth=Number(layerName.charAt(0)+layerName.charAt(1));
if (layerName.charAt(2)=="."){otherDepth=Number(layerName.charAt(0)+layerName.charAt(1)+layerName.charAt(2)+layerName.charAt(3));}
if (depthLevel>otherDepth){
app.activeDocument.activeLayer.moveBefore (app.activeDocument.layers[i]);
placed=true;
break;
}
}
}
if(!placed){
for (i=0; i<app.activeDocument.layers.length; i++) {
var layerName = app.activeDocument.layers[i].name;
if (layerName.charAt(0)=="+"||layerName.charAt(0)=="-"){
var otherDepth=Number(layerName.charAt(1));
if (layerName.charAt(2)=="."){otherDepth=Number(layerName.charAt(0)+layerName.charAt(1)+layerName.charAt(2)+layerName.charAt(3));}
if (depthLevel<otherDepth){
app.activeDocument.activeLayer.moveAfter (app.activeDocument.layers[i]);
}
placed=true;
}
};
placed=false;
}
//alert(depthLevel);
if (depthLevel>0){
ad.activeLayer.name = "+"+depthLevel+" "+currentLayerName;
} else {
ad.activeLayer.name = depthLevel+" "+currentLayerName;
}
if(depthLevel==0){ad.activeLayer.name = "+"+Math.abs(depthLevel)+" "+currentLayerName;}
}
function getLayerIndex(){
for(i=0; i < app.activeDocument.layers.length; )
{
if(app.activeDocument.layers[i]==app.activeDocument.activeLayer)
{currentLayer=i;
break;
}
else{ i++; }
}
}
function red(){
var idsetd = charIDToTypeID( "setd" );
var desc1309 = new ActionDescriptor();
var idnull = charIDToTypeID( "null" );
var ref756 = new ActionReference();
var idLyr = charIDToTypeID( "Lyr " );
var idOrdn = charIDToTypeID( "Ordn" );
var idTrgt = charIDToTypeID( "Trgt" );
ref756.putEnumerated( idLyr, idOrdn, idTrgt );
desc1309.putReference( idnull, ref756 );
var idT = charIDToTypeID( "T   " );
var desc1310 = new ActionDescriptor();
var idchannelRestrictions = stringIDToTypeID( "channelRestrictions" );
var list233 = new ActionList();
var idChnl = charIDToTypeID( "Chnl" );
var idGrn = charIDToTypeID( "Grn " );
list233.putEnumerated( idChnl, idGrn );
var idChnl = charIDToTypeID( "Chnl" );
var idBl = charIDToTypeID( "Bl  " );
list233.putEnumerated( idChnl, idBl );
desc1310.putList( idchannelRestrictions, list233 );
var idLefx = charIDToTypeID( "Lefx" );
var desc1311 = new ActionDescriptor();
var idScl = charIDToTypeID( "Scl " );
var idPrc = charIDToTypeID( "#Prc" );
desc1311.putUnitDouble( idScl, idPrc, 416.666667 );
var idLefx = charIDToTypeID( "Lefx" );
desc1310.putObject( idLefx, idLefx, desc1311 );
var idLyr = charIDToTypeID( "Lyr " );
desc1309.putObject( idT, idLyr, desc1310 );
executeAction( idsetd, desc1309, DialogModes.NO );
try{
app.activeDocument.activeLayer.opacity=100;
app.activeDocument.activeLayer.translate((0-depth*2),0);
}catch(e){alert(e)}
app.activeDocument.activeLayer.name = currentLayerName+" Right"
}
function cyan(){
var idsetd = charIDToTypeID( "setd" );
var desc1324 = new ActionDescriptor();
var idnull = charIDToTypeID( "null" );
var ref765 = new ActionReference();
var idLyr = charIDToTypeID( "Lyr " );
var idOrdn = charIDToTypeID( "Ordn" );
var idTrgt = charIDToTypeID( "Trgt" );
ref765.putEnumerated( idLyr, idOrdn, idTrgt );
desc1324.putReference( idnull, ref765 );
var idT = charIDToTypeID( "T   " );
var desc1325 = new ActionDescriptor();
var idchannelRestrictions = stringIDToTypeID( "channelRestrictions" );
var list241 = new ActionList();
var idChnl = charIDToTypeID( "Chnl" );
var idRd = charIDToTypeID( "Rd  " );
list241.putEnumerated( idChnl, idRd );
desc1325.putList( idchannelRestrictions, list241 );
var idLefx = charIDToTypeID( "Lefx" );
var desc1326 = new ActionDescriptor();
var idScl = charIDToTypeID( "Scl " );
var idPrc = charIDToTypeID( "#Prc" );
desc1326.putUnitDouble( idScl, idPrc, 416.666667 );
var idLefx = charIDToTypeID( "Lefx" );
desc1325.putObject( idLefx, idLefx, desc1326 );
var idLyr = charIDToTypeID( "Lyr " );
desc1324.putObject( idT, idLyr, desc1325 );
executeAction( idsetd, desc1324, DialogModes.NO );
try{
app.activeDocument.activeLayer.opacity=100
app.activeDocument.activeLayer.translate((depth),0);
}catch(e){alert(e)}
app.activeDocument.activeLayer.name = currentLayerName+" Left"
}
var found = false;
for (var a=0; a<app.activeDocument.channels.length; a++){
    if(app.activeDocument.channels[a].name == '3D0X536:'){found = true}
    }
if (!found){
var signature = app.activeDocument.channels.add();
signature.name = '3D0X536:'
app.activeDocument.activeLayer = app.activeDocument.layers[0];
}
return (ad.name);
}
function shiftLR(val) {
    step = app.activeDocument.width/100;
    var editstep = 0.3;
    var nudge;
    var cid = app.activeDocument.activeLayer.id;
    var al = app.activeDocument.activeLayer;
    var alname = app.activeDocument.activeLayer.name;
    var left = al.layers[0];
    var right = al.layers[1];
    if (val < 0) { nudge = 0- Number(step*editstep);} else {nudge = Number(step*editstep);}
    left.translate((0-(nudge)),0);
    right.translate(((nudge)),0);
    try{
    if (alname.charAt(0)=="+"||alname.charAt(0)=="-"){
    var cDepth=Number(alname.charAt(0)+alname.charAt(1));
    if (alname.charAt(2)=="."){cDepth=Number(alname.charAt(0)+alname.charAt(1)+alname.charAt(2)+alname.charAt(3));}
    }
    if(val < 0) {
    cDepth = Number((cDepth - editstep ).toFixed(1));
    } else {
        cDepth = Number((cDepth + editstep ).toFixed(1));

        }

var ln = app.activeDocument.activeLayer.name;
var lnoriginal = ln.substr(ln.indexOf(' ')+1);
if (cDepth>0||cDepth==0){
app.activeDocument.activeLayer.name = "+"+cDepth+" "+lnoriginal;
} else if (cDepth<0){
app.activeDocument.activeLayer.name = cDepth+" "+lnoriginal;
}
checkOrder();
checkOrder();
selectLayerById(cid);
} catch(e){alert(e)}
var idcollapseAllGroupsEvent = stringIDToTypeID( "collapseAllGroupsEvent" );
var desc2 = new ActionDescriptor();
executeAction( idcollapseAllGroupsEvent, desc2, DialogModes.NO );
    }

function checkOrder(){
var depthLevel= 4;
var ad = app.activeDocument;
var depthStep = (8/(numberOfLayers-1));
for (var i = 0; i<app.activeDocument.layers.length; i++) {
    var currentLayerName = app.activeDocument.layers[i].name;
    app.activeDocument.activeLayer = app.activeDocument.layers[i];
     if (currentLayerName.charAt(0)=="+"||currentLayerName.charAt(0)=="-"){
    resort(currentLayerName, i);
    }
    }
function resort(layerToSort, index) {
    if (layerToSort.charAt(0)=="+"||layerToSort.charAt(0)=="-"){
    var layerToSortDepth=Number(layerToSort.charAt(0)+layerToSort.charAt(1));
    if (layerToSort.charAt(2)=="."){layerToSortDepth=Number(layerToSort.charAt(0)+layerToSort.charAt(1)+layerToSort.charAt(2)+layerToSort.charAt(3));}
    }
    for (z=0; z<app.activeDocument.layers.length; z++) {
    var layerName = app.activeDocument.layers[z].name;
    if (layerName.charAt(0)=="+"||layerName.charAt(0)=="-"){
        var otherDepth=Number(layerName.charAt(0)+layerName.charAt(1));
        if (layerName.charAt(2)=="."){otherDepth=Number(layerName.charAt(0)+layerName.charAt(1)+layerName.charAt(2)+layerName.charAt(3));}
        if (layerToSortDepth>otherDepth && layerToSortDepth != otherDepth){
app.activeDocument.activeLayer.moveBefore (app.activeDocument.layers[z]);
break;
}
}
}
}
}
function selectLayerById(id,add){   
var ref = new ActionReference();  
ref.putIdentifier(charIDToTypeID('Lyr '), id);  
var desc = new ActionDescriptor();  
desc.putReference(charIDToTypeID("null"), ref );  
desc.putBoolean( charIDToTypeID( "MkVs" ), false );   
try{  
executeAction(charIDToTypeID("slct"), desc, DialogModes.NO );  
}catch(e){}  
};  
function check(){
    if(app.documents.length>0){
    var found = false;
for (var a=0; a<app.activeDocument.channels.length; a++){
    if(app.activeDocument.channels[a].name == '3D0X536:'){found = true};
    } 
return ([found, app.activeDocument.name, app.activeDocument.layers.length]);
} else { return ([false, 'nothingtoworkon3d', 0]); }
}
function getDocDetails(){
    return ([app.activeDocument.name, app.activeDocument.layers.length]);
    }
function openTestDocument(){
    var userFolder = (Folder.myDocuments.fsName).toString().replace(/\\/g, '/');
	userFolder += "/3DLayersAnaglyph";
    var templateFile = new File( userFolder + '/3DLA_Test.psd' );
	var fileRef = new File(templateFile);
	var docRef = app.open(fileRef);
    var idDplc = charIDToTypeID( "Dplc" );
    var desc28 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref9 = new ActionReference();
        var idDcmn = charIDToTypeID( "Dcmn" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idFrst = charIDToTypeID( "Frst" );
        ref9.putEnumerated( idDcmn, idOrdn, idFrst );
    desc28.putReference( idnull, ref9 );
    var idNm = charIDToTypeID( "Nm  " );
    desc28.putString( idNm, """3DLATest""" );
executeAction( idDplc, desc28, DialogModes.NO );
var idslct = charIDToTypeID( "slct" );
var desc29 = new ActionDescriptor();
var idnull = charIDToTypeID( "null" );
var ref10 = new ActionReference();
var idDcmn = charIDToTypeID( "Dcmn" );
ref10.putOffset( idDcmn, -1 );
desc29.putReference( idnull, ref10 );
executeAction( idslct, desc29, DialogModes.NO );
var idCls = charIDToTypeID( "Cls " );
var desc56 = new ActionDescriptor();
var idSvng = charIDToTypeID( "Svng" );
var idYsN = charIDToTypeID( "YsN " );
var idN = charIDToTypeID( "N   " );
desc56.putEnumerated( idSvng, idYsN, idN );
var idDocI = charIDToTypeID( "DocI" );
desc56.putInteger( idDocI, 530 );
var idforceNotify = stringIDToTypeID( "forceNotify" );
desc56.putBoolean( idforceNotify, true );
executeAction( idCls, desc56, DialogModes.NO );    
     return('opened');

    }